#!/bin/sh

## Compile the cbmlink server programs

## Output directory for the programs
: ${PRGDIR="../cbmbasic"}

set -eu
<&-

## Function to execute critical commands
perform() { eval "$@" || exit $?; }
#perform() { echo "$@" >&2; eval "$@" || exit $?; }

## Function to build binaries for the specified cable and target
build() {
    host="$1"
    mem="$2"
    shift 2
    while { cable="${1:-}"; shift; }
    do
	[ -d "$PRGDIR/$cable" ] || perform mkdir "$PRGDIR/$cable"
	[ -d "$PRGDIR/$cable/$host" ] || perform mkdir "$PRGDIR/$cable/$host"
	perform xa basic.s \
-Ihost/"$host" -Ihost -Imem/"$mem" -Imem -Icable/"$cable" -Icable
	cmp -s a.o65 "$PRGDIR/$cable/$host/$mem".prg || \
	    mv a.o65 "$PRGDIR/$cable/$host/$mem".prg
    done
}

[ -d "$PRGDIR" ] || perform mkdir "$PRGDIR"

# Build the PET and VIC-20 binaries
for h in pet3001 pet4001 vic20
do
    build $h plain c2n232 pc64 kontros prlink88 prlink48 transnib c64net
done
build vic20 plain x1541
# Build the PET binaries for cassette port #2
build pet3001 port2 c2n232
build pet4001 port2 c2n232

# Build the C64 and C128 binaries
for h in c64 c128
do
    for m in plain pia reu piareu
    do
	build $h $m c2n232 serial pc64 kontros prlink88 prlink48 transnib \
		c64net x1541
    done
done

# Build the 264 series binaries (c16, c116, plus/4)
build c264 plain c2n232 serial x1541
# Build the PET II series binaries (510/P500, 610/710/B-128, 620/720/B-256)
build p500 plain c2n232 serial
build b128 plain c2n232 serial
build b256 plain c2n232 serial
